=== packaging/macports/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

PortSystem          1.0
PortGroup           github 1.0

github.setup        tulip-control gr1c 0.13.2 v

categories          math devel
platforms           darwin
maintainers         {cds.caltech.edu:slivingston @slivingston} \
                    openmaintainer
license             BSD

description         Tools for GR(1) synthesis and related activities

long_description    A collection of tools for GR(1) synthesis and related \
                    activities.  Its core functionality is checking \
                    realizability of and synthesizing strategies for GR(1) \
                    specifications, though it does much more.

homepage            http://scottman.net/2012/gr1c

checksums           rmd160  b5d45b6eccb6bd70b4e3d067b6e862488c97def0 \
                    sha256  48e43eb5790a32b59cb0f3528eedb1d40072730e6046541ff593e812ad26f506 \
                    size    191959

depends_build       port:bison \
                    port:flex

depends_lib         port:libcudd

configure.cmd       true

build.args          prefix="${prefix}"

foreach arch ${configure.universal_archs} {
    lappend merger_build_args(${arch}) \
                    CC='${configure.cc} -arch ${arch}' \
                    LD='ld -r -arch ${arch}'
}

if {(!${universal_possible} || ![variant_isset universal]) && [info exists merger_build_args(${build_arch})]} {
    build.args-append $merger_build_args(${build_arch})
}

test.run            yes
test.target         check
test.args           {*}${build.args}

destroot.target     install
destroot.args       {*}${build.args}
